package bootcampdia8.FilmCrud.model;

import bootcampdia8.FilmCrud.FilmAndActorDTO;
import javax.persistence.*;
import java.util.List;

@Entity
@Table(name="film")
//@NamedNativeQuery(name="getFilmsAndActors",
//        query = "SELECT f.film_id, f.title, f.description, f.length, f.release_year, a.actor_id, a.first_name, a.last_name FROM film f " +
//                "JOIN film_actor fa ON f.id =: fa.film_id" +
//                "JOIN actor a ON fa.actor_id =: a.actor_id",
//                resultClass = FilmAndActorDTO.class)
@NamedQuery(name="Film.joinFilmsAndActors",
        query = "SELECT new bootcampdia8.FilmCrud.FilmAndActorDTO(f.id, f.title, f.description, a.actor_id, a.first_name, a.last_name)" +
                "from Film f " +
                "JOIN f.actors a")
public class Film {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "film_id")
    private long id;

    @Column(name = "title")
    private String title;

    @Column(name = "description")
    private String description;

    @ManyToOne(cascade = CascadeType.ALL)
    @JoinColumn(name="language_id", referencedColumnName = "language_id")
    private Language language;

    @Column(name="length")
    private long duration;

    @Column(name="release_year")
    private long releaseYear;

    @ManyToMany(mappedBy = "films")
    private List<Actor> actors;

    public List<Actor> getActors() {
        return actors;
    }

    public void setActors(List<Actor> actors) {
        this.actors = actors;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }


    public long getDuration() {
        return duration;
    }

    public void setDuration(long duration) {
        this.duration = duration;
    }

    public long getReleaseYear() {
        return releaseYear;
    }

    public void setReleaseYear(long releaseYear) {
        this.releaseYear = releaseYear;
    }

    public Language getLanguage() {
        return language;
    }

    public void setLanguage(Language language) {
        this.language = language;
    }
}
