package bootcampdia8.FilmCrud.repository;

import bootcampdia8.FilmCrud.FilmAndActorDTO;
import bootcampdia8.FilmCrud.FilmAndLanguageDTO;
import bootcampdia8.FilmCrud.model.Actor;
import bootcampdia8.FilmCrud.model.Film;
import bootcampdia8.FilmCrud.model.Language;
import org.hibernate.annotations.NamedQuery;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.sql.Timestamp;
import java.time.LocalDate;
import java.util.Date;
import java.util.List;
import java.util.Optional;

@Repository
public interface FilmRepository extends JpaRepository<Film, Long> {

    @Query("select f from Film f" +
            " JOIN f.language l" +
            "   where l.id = :langId")
    public List<Film> obtenerPorLenguaje(@Param("langId") long langId);

    public List<Film> findByLanguage(Language language);

    public Film findByTitle(String title);

    public List<Film> findByReleaseYearBetween(long date1, long date2);

//    @Query("SELECT new bootcampdia8.FilmCrud.FilmAndActorDTO(f.id, a.actor_id)" +
//            "from Film f " +
//            "JOIN f.actors a")
    public List<FilmAndActorDTO> joinFilmsAndActors();

    @Query("SELECT new bootcampdia8.FilmCrud.FilmAndLanguageDTO(f.id, f.title, l.name)" +
        "from Film f " +
        "JOIN f.language l")
    public List<FilmAndLanguageDTO> joinFilmsAndLanguages();
}
